xonotic/all

1307 lines
36 KiB
Plaintext
Raw Normal View History

2010-03-18 15:46:07 +00:00
#!/bin/sh
# vim: filetype=zsh
2010-03-18 15:46:07 +00:00
set -e
# I use this in EVERY shell script ;)
LF="
"
d00=`pwd`
while ! [ -f ./all ]; do
if [ x"`pwd`" = x"/" ]; then
echo "Cannot find myself."
echo "Please run this script with the working directory inside a Xonotic checkout."
exit 1
fi
cd ..
done
export d0=`pwd`
SELF="$d0/all"
# If we are on WINDOWS:
case "$0" in
all|*/all)
case "`uname`" in
MINGW*|Win*)
# Windows hates users. So this script has to copy itself elsewhere first...
2010-04-02 18:35:19 +00:00
cp "$SELF" ../all.xonotic.sh
export WE_HATE_OUR_USERS=1
exec ../all.xonotic.sh "$@"
;;
esac
;;
esac
2010-03-29 13:21:24 +00:00
msg()
{
2010-08-06 09:48:00 +00:00
echo >&2 "$*"
2010-03-29 13:21:24 +00:00
}
2010-06-22 15:05:06 +00:00
self=`git hash-object "$SELF"`
2010-03-29 13:21:24 +00:00
checkself()
{
2010-06-22 15:05:06 +00:00
self_new=`git hash-object "$SELF"`
2010-03-29 13:21:24 +00:00
if [ x"$self" != x"$self_new" ]; then
msg "./all has changed."
if [ -z "$XONOTIC_FORBID_RERUN_ALL" ]; then
msg "Rerunning the requested operation to make sure."
export XONOTIC_FORBID_RERUN_ALL=1
exec "$SELF" "$@"
2010-03-29 13:21:24 +00:00
else
msg "Please try $SELF update, and then retry your requested operation."
2010-03-29 13:21:24 +00:00
exit 1
fi
fi
2010-03-29 13:24:49 +00:00
return 0
2010-03-29 13:21:24 +00:00
}
verbose()
{
2010-03-29 13:21:24 +00:00
msg "+ $*"
"$@"
}
2010-04-02 19:25:08 +00:00
visible_repo_name()
{
case "$1" in
.)
echo "the root directory"
;;
*)
echo "\"$1\""
;;
esac
}
2010-04-02 19:11:17 +00:00
check_mergeconflict()
{
if git ls-files -u | grep ' 1 '; then
echo
echo "MERGE CONFLICT."
echo "change into the \"$1\" project directory, and then:"
echo "- edit the files mentioned above with your favorite editor,"
echo " and fix the conflicts (marked with <<<<<<< blocks)"
echo "- for binary files, you can select the files using"
echo " git checkout --ours or git checkout --theirs"
echo "- when done with a file, 'git add' the file"
echo "- when done, 'git commit'"
echo
exit 1
fi
}
2010-05-09 17:40:25 +00:00
yesno()
{
yesno=
while [ x"$yesno" != x"y" -a x"$yesno" != x"n" ]; do
2010-05-15 18:11:23 +00:00
eval "$2"
2010-05-09 17:40:25 +00:00
echo "$1"
IFS= read -r yesno
done
[ x"$yesno" = x"y" ]
}
2010-04-02 19:11:17 +00:00
enter()
{
2010-07-18 15:18:15 +00:00
$2 cd "$1" || exit 1
2010-04-02 19:11:17 +00:00
check_mergeconflict "$1"
}
2010-03-26 07:59:06 +00:00
repos_urls="
2010-05-15 20:24:38 +00:00
. | | master |
data/xonotic-data.pk3dir | | master |
data/xonotic-maps.pk3dir | | master |
data/xonotic-music.pk3dir | | master |
data/xonotic-nexcompat.pk3dir | | master | no
mediasource | | master | no
2010-05-15 20:24:38 +00:00
darkplaces | | div0-stable | svn
fteqcc | git://github.com/Blub/qclib.git | master |
div0-gittools | | master | no
2010-05-15 20:24:38 +00:00
netradiant | | master |
2010-07-05 08:52:14 +00:00
d0_blind_id | http://github.com/divVerent/d0_blind_id.git | master |
2010-03-18 15:46:07 +00:00
"
# todo: in darkplaces, change repobranch to div0-stable
2010-03-18 15:46:07 +00:00
repos=`echo "$repos_urls" | grep . | cut -d '|' -f 1 | tr -d ' '`
base=`git config remote.origin.url`
2010-05-10 06:39:45 +00:00
case "$base" in
*/xonotic.git)
base=${base%xonotic.git}
;;
*)
echo "The main repo is not xonotic.git, what have you done?"
exit 1
;;
esac
repourl()
{
2010-07-04 19:37:09 +00:00
repo_t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 2 | tr -d ' '`
if [ -n "$repo_t" ]; then
case "$repo_t" in
2010-05-08 16:45:50 +00:00
*://*)
2010-07-04 19:37:09 +00:00
echo "$repo_t"
2010-05-08 16:45:50 +00:00
;;
*)
2010-07-04 19:37:09 +00:00
echo "$base$repo_t"
2010-05-08 16:45:50 +00:00
;;
esac
else
if [ x"$1" = x"." ]; then
echo "$base""xonotic.git"
else
echo "$base${1##*/}.git"
fi
fi
}
repobranch()
{
2010-07-04 19:37:09 +00:00
repo_t=`echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 3 | tr -d ' '`
if [ -n "$repo_t" ]; then
echo "$repo_t"
else
echo "master"
fi
}
2010-05-15 20:24:38 +00:00
repoflags()
{
echo "$repos_urls" | grep "^$1 " | cut -d '|' -f 4 | tr -d ' '
}
listrepos()
{
for d in $repos; do
p="${d%dir}"
f="`repoflags "$d"`"
# if we have the dir, always keep it
if [ -d "$d" ]; then
msg "Repository $d enabled because it already exists"
echo "$d"
continue
fi
# if .yes file exists, always keep it
if [ -f "$d.yes" ]; then
msg "Repository $d enabled by a .yes file"
echo "$d"
continue
fi
# if we have .no file, skip
if [ -f "$d.no" ]; then
msg "Repository $d disabled by a .no file, delete $p.no to enable"
continue
fi
# if we have matching pk3, skip
if [ x"$p" != x"$d" ] && [ -f "$p" ]; then
msg "Repository $d disabled by matching .pk3 file, delete $p or create $d.yes to enable"
continue
fi
# if "no" flag is set, skip
case ",$f," in
*,no,*)
msg "Repository $d disabled by default, create $d.yes to enable"
continue
;;
esac
2010-08-25 05:56:00 +00:00
# default: enable
msg "Repository $d enabled by default"
echo "$d"
done
}
repos=`listrepos`
2010-03-26 07:59:06 +00:00
2010-03-18 15:57:21 +00:00
if [ "$#" = 0 ]; then
set -- help
fi
2010-03-18 15:46:07 +00:00
cmd=$1
shift
fix_upstream_rebase()
{
if [ -z "$r_me" ] || [ -z "$r_other" ]; then
return
fi
r_base=`git merge-base "$r_me" "$r_other"`
# no merge-base? upstream did filter-branch
if [ -n "$r_base" ]; then
# otherwise, check if the two histories are "similar"
r_l_me=`git log --pretty="format:%s" "$r_other".."$r_me" | grep -v "^Merge" | sort -u`
r_l_other=`git log --pretty="format:%s" "$r_me".."$r_other" | grep -v "^Merge" | sort -u`
# heuristics: upstream rebase/filter-branch if more than 50% of the commits of one of the sides are in the other too
r_lc_me=`echo "$r_l_me" | wc -l`
r_lc_other=`echo "$r_l_other" | wc -l`
r_lc_together=`{ echo "$r_l_me"; echo "$r_l_other"; } | sort -u | wc -l`
r_lc_same=$(($r_lc_me + $r_lc_other - $r_lc_together))
2010-08-04 10:39:44 +00:00
if [ $(( $r_lc_same * 2 )) -gt $(( $r_lc_me )) ] || [ $(( $r_lc_same * 2 )) -gt $(( $r_lc_other )) ]; then
if yesno "Probable upstream rebase detected, automatically fix?" 'git log --oneline --graph --date-order --left-right "$r_other"..."$r_me"'; then
git reset --hard "$r_me"
git pull --rebase
return 1
fi
fi
fi
return 0
}
fix_upstream_rebase_mergeok()
{
r_me=`git rev-parse --revs-only HEAD^1 2>/dev/null || true`
r_other=`git rev-parse --revs-only HEAD^2 2>/dev/null || true`
fix_upstream_rebase
}
fix_upstream_rebase_mergefail()
{
r_me=`git rev-parse --revs-only HEAD 2>/dev/null || true`
r_other=`git rev-parse --revs-only MERGE_HEAD 2>/dev/null || true`
fix_upstream_rebase
}
fix_git_config()
{
verbose git config core.autocrlf input
if [ -z "`git config push.default`" ]; then
verbose git config push.default current # or is tracking better?
fi
}
2010-03-18 15:46:07 +00:00
case "$cmd" in
fix_upstream_rebase)
for d in $repos; do
2010-08-04 10:34:36 +00:00
enter "$d0/$d" verbose
verbose fix_upstream_rebase_mergefail && verbose fix_upstream_rebase_mergeok
done
;;
2010-03-20 13:20:07 +00:00
update|pull)
allow_pull=true
if [ x"$1" = x"-N" ]; then
allow_pull=false
fi
for d in $repos; do
url=`repourl "$d"`
branch=`repobranch "$d"`
2010-03-18 15:46:07 +00:00
if [ -d "$d0/$d" ]; then
if $allow_pull; then
enter "$d0/$d" verbose
fix_git_config
verbose git config remote.origin.url "$url"
verbose git config remote.origin.fetch "+refs/heads/*:refs/remotes/origin/*"
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
if git config branch.$r.remote >/dev/null 2>&1; then
if ! verbose git pull; then
2010-08-04 19:33:55 +00:00
fix_upstream_rebase_mergefail || true
check_mergeconflict "$d"
echo "Pulling failed. Press ENTER to continue, or Ctrl-C to abort."
read -r DUMMY
else
fix_upstream_rebase_mergeok || true
fi
fi
cd "$d00"
checkself "$cmd" "$@"
cd "$d0/$d"
verbose git remote prune origin
cd "$d0"
fi
2010-03-18 15:46:07 +00:00
else
verbose git clone "$url" "$d0/$d"
enter "$d0/$d" verbose
fix_git_config
if [ "$branch" != "master" ]; then
verbose git checkout --track -b "$branch" origin/"$branch"
fi
cd "$d0"
2010-03-18 15:46:07 +00:00
fi
done
;;
update-maps)
misc/tools/xonotic-map-compiler-autobuild download
;;
checkout|switch)
2010-08-14 00:46:07 +00:00
checkoutflags=
if [ x"$1" = x"-f" ]; then
checkoutflags=-f
shift
fi
2010-03-18 15:46:07 +00:00
remote=$1
branch=$2
if [ -z "$branch" ]; then
2010-06-17 12:26:24 +00:00
case "$remote" in
origin/*)
branch=${remote#origin/}
remote=origin
;;
*)
branch=$remote
remote=origin
;;
esac
2010-03-18 15:46:07 +00:00
fi
exists=false
for d in $repos; do
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
b=$branch
if [ -n "$b" ] && git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
2010-03-18 15:46:07 +00:00
exists=true
2010-08-14 00:46:07 +00:00
verbose git checkout $checkoutflags "$b"
elif [ -n "$b" ] && git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
2010-03-18 15:46:07 +00:00
exists=true
2010-08-14 00:46:07 +00:00
verbose git checkout $checkoutflags --track -b "$b" "$remote/$b"
2010-03-18 15:46:07 +00:00
else
b=`repobranch "$d"`
if git rev-parse "refs/heads/$b" >/dev/null 2>&1; then
exists=true
2010-08-14 00:46:07 +00:00
verbose git checkout $checkoutflags "$b"
elif git rev-parse "refs/remotes/$remote/$b" >/dev/null 2>&1; then
exists=true
2010-08-14 00:46:07 +00:00
verbose git checkout $checkoutflags --track -b "$b" "$remote/$b"
else
echo "WTF? Not even branch $b doesn't exist in $d"
exit 1
fi
2010-03-18 15:46:07 +00:00
fi
2010-04-02 18:14:19 +00:00
cd "$d00"
2010-04-02 21:14:58 +00:00
checkself "$cmd" "$@"
2010-04-02 18:14:19 +00:00
cd "$d0"
2010-03-18 15:46:07 +00:00
done
if ! $exists; then
echo "The requested branch was not found in any repository."
fi
exec "$SELF" branch
2010-03-18 15:46:07 +00:00
;;
branch)
2010-03-20 13:23:39 +00:00
remote=$1
branch=$2
srcbranch=$3
2010-03-20 13:23:39 +00:00
if [ -z "$branch" ]; then
branch=$remote
remote=origin
fi
if [ -z "$branch" ]; then
for d in $repos; do
2010-04-02 19:11:17 +00:00
enter "$d0/$d"
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
echo "$d is at $r"
cd "$d0"
done
else
for d in $repos; do
2010-04-02 19:25:08 +00:00
dv=`visible_repo_name "$d"`
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
if git rev-parse "refs/heads/$branch" >/dev/null 2>&1; then
echo "Already having this branch in $dv."
else
2010-05-09 17:40:25 +00:00
if yesno "Branch in $dv?"; then
if [ -n "$srcbranch" ]; then
b=$srcbranch
else
b=origin/"`repobranch "$d"`"
verbose git fetch origin || true
fi
# TODO do this without pushing
2010-05-23 12:51:44 +00:00
verbose git checkout -b "$branch" "$b"
verbose git config "branch.$branch.remote" "$remote"
2010-05-25 11:01:32 +00:00
verbose git config "branch.$branch.merge" "refs/heads/$branch"
fi
fi
cd "$d0"
done
"$SELF" branch
fi
2010-03-18 15:46:07 +00:00
;;
branches)
for d in $repos; do
cd "$d0/$d" # am in a pipe, shouldn't use enter
git branch -a -v -v | cut -c 3- | sed "s/^(no branch)/(no_branch)/" | sed "s,^,$d ,"
cd "$d0"
done | {
branches_list=
# branches_repos_*=
while read -r d BRANCH REV UPSTREAM TEXT; do
2010-06-17 12:26:24 +00:00
if [ x"$BRANCH" = x"`repobranch "$d"`" ]; then
continue
fi
case "$UPSTREAM" in
\[*)
UPSTREAM=${UPSTREAM#\[}
UPSTREAM=${UPSTREAM%\]}
UPSTREAM=${UPSTREAM%:*}
;;
*)
TEXT="$UPSTREAM $TEXT"
UPSTREAM=
;;
esac
if [ x"$REV" = x"->" ]; then
continue
fi
BRANCH=${BRANCH#remotes/}
ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
branches_list="$branches_list $BRANCH" # TEH SORT MAKEZ IT UNIEQ
eval "r=\$branches_repos_$ID"
2010-06-17 12:26:24 +00:00
case "$UPSTREAM" in
'')
r="$r $d"
;;
*)
r="$r $d:$UPSTREAM"
;;
esac
eval "branches_repos_$ID=\$r"
done
echo -n "$branches_list" | xargs -n 1 echo | sort -u | while IFS= read -r BRANCH; do
ID=`echo "$BRANCH" | tr -c "A-Za-z0-9." "_"`
eval "r=\$branches_repos_$ID"
2010-06-17 12:26:24 +00:00
printf "%-60s %s\n" "$BRANCH" "$r"
#echo "$BRANCH: $r"
done
}
;;
merge)
for d in $repos; do
2010-04-02 19:25:08 +00:00
dv=`visible_repo_name "$d"`
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
if git log HEAD..origin/"`repobranch "$d"`" | grep .; then
# we have uncommitted changes
2010-05-09 17:40:25 +00:00
if yesno "Could merge from \"`repobranch "$d"`\" into \"$r\" in $dv. Do it?"; then
if ! verbose git merge origin/"`repobranch "$d"`"; then
2010-04-02 19:11:17 +00:00
check_mergeconflict "$d"
exit 1 # this should ALWAYS be fatal
fi
fi
fi
cd "$d0"
done
;;
push|commit)
submit=$1
2010-03-20 13:20:07 +00:00
for d in $repos; do
2010-04-02 19:25:08 +00:00
dv=`visible_repo_name "$d"`
2010-04-15 09:38:55 +00:00
enter "$d0/$d" verbose
2010-03-20 13:20:07 +00:00
r=`git symbolic-ref HEAD`
r=${r#refs/heads/}
2010-06-22 15:32:43 +00:00
diffdata=`git diff --color HEAD`
if [ -n "$diffdata" ]; then
# we have uncommitted changes
2010-06-22 15:32:43 +00:00
if yesno "Uncommitted changes in \"$r\" in $dv. Commit?" 'echo "$diffdata" | less -r'; then
verbose git commit -a
fi
fi
2010-04-16 17:36:41 +00:00
rem=`git config "branch.$r.remote" || echo origin`
bra=`git config "branch.$r.merge" || echo "$r"`
2010-07-09 20:54:58 +00:00
upstream="$rem/${bra#refs/heads/}"
2010-06-22 15:28:25 +00:00
if ! git rev-parse "$upstream" >/dev/null 2>&1; then
2010-06-22 15:34:51 +00:00
upstream="origin/`repobranch "$d"`"
fi
2010-06-22 15:35:05 +00:00
logdata=`git log --color "$upstream".."$r"`
2010-06-22 15:33:56 +00:00
if [ -n "$logdata" ]; then
if yesno "Push \"$r\" in $dv?" 'echo "$logdata" | less -r'; then
verbose git push "$rem" HEAD
fi
2010-03-20 13:20:07 +00:00
fi
if [ x"$submit" = x"-s" ]; then
case "$r" in
*/*)
verbose git push "$rem" HEAD:"${bra%%/*}/finished/${bra#*/}"
;;
esac
fi
2010-03-20 13:20:07 +00:00
cd "$d0"
done
;;
2010-03-24 12:11:30 +00:00
compile)
if [ -n "$WE_HATE_OUR_USERS" ]; then
TARGETS="sv-debug cl-debug"
2010-06-04 18:40:49 +00:00
if [ -z "$CC" ]; then
export CC=gcc
fi
2010-07-09 20:48:47 +00:00
elif [ x"`uname`" = x"Darwin" ]; then
case "`uname -r`" in
?.*)
TARGETS="sv-debug cl-debug sdl-debug"
;;
*)
# AGL cannot be compiled on systems with a kernel > 10.x (Snow Leopard)
TARGETS="sv-debug sdl-debug"
;;
esac
2010-07-08 20:12:54 +00:00
export CC="gcc -I$PWD/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks/SDL.framework/Headers -F$PWD/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks"
else
TARGETS="sv-debug cl-debug sdl-debug"
fi
case "$1" in
-c)
cleand0=true
cleandp=true
cleanqcc=true
cleanqc=true
shift
;;
*)
cleand0=false
cleandp=false
cleanqcc=false
cleanqc=false
;;
esac
if [ $# -gt 0 ] && [ x"$1" = x"" ]; then
# if we give the command make the arg "", it will surely fail (invalid filename),
# so better handle it as an empty client option
BAD_TARGETS=" "
shift
elif [ -n "$1" ]; then
BAD_TARGETS=
TARGETS_SAVE=$TARGETS
TARGETS=
for X in $1; do
case "$X" in
sdl)
TARGETS="$TARGETS sdl-debug"
;;
glx|agl|wgl)
TARGETS="$TARGETS cl-debug"
;;
dedicated)
TARGETS="$TARGETS sv-debug"
;;
*)
BAD_TARGETS="$BAD_TARGETS $X"
;;
esac
done
2010-07-21 18:01:32 +00:00
if [ -n "$TARGETS" ]; then # at least a valid client
shift
else # no valid client, let's assume this option is not meant to be a client then
TARGETS=$TARGETS_SAVE
BAD_TARGETS=
fi
fi
if [ -z "$MAKEFLAGS" ]; then
if [ -f /proc/cpuinfo ]; then
ncpus=$((`grep -c '^processor :' /proc/cpuinfo`+0))
if [ $ncpus -gt 1 ]; then
MAKEFLAGS=-j$ncpus
fi
fi
2010-05-08 18:54:22 +00:00
if [ -n "$WE_HATE_OUR_USERS" ]; then
MAKEFLAGS="$MAKEFLAGS DP_MAKE_TARGET=mingw LIB_JPEG= CFLAGS_LIBJPEG="
2010-05-08 18:54:22 +00:00
fi
fi
enter "$d0/d0_blind_id" verbose
if ! [ -f Makefile ]; then
verbose sh autogen.sh
verbose ./configure
fi
if $cleand0; then
verbose make $MAKEFLAGS clean
fi
verbose make $MAKEFLAGS
2010-04-15 09:38:55 +00:00
enter "$d0/fteqcc" verbose
if $cleanqcc; then
verbose make $MAKEFLAGS clean
fi
verbose make $MAKEFLAGS
2010-04-15 09:38:55 +00:00
enter "$d0/data/xonotic-data.pk3dir" verbose
if $cleanqc; then
verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS clean
fi
verbose make FTEQCC="$d0/fteqcc/fteqcc.bin" "$@" $MAKEFLAGS
2010-04-15 09:38:55 +00:00
enter "$d0/darkplaces" verbose
if [ x"$BAD_TARGETS" = x" " ]; then
echo "Warning: invalid empty client, default clients will be used."
fi
if $cleandp; then
verbose make $MAKEFLAGS clean
fi
for T in $TARGETS; do
verbose make $MAKEFLAGS "$@" "$T"
done
for T in $BAD_TARGETS; do
echo "Warning: discarded invalid client $T."
done
verbose "$SELF" update-maps
;;
run)
if [ -n "$WE_HATE_OUR_USERS" ]; then
client=
export PATH="$d0/misc/buildfiles/win32:$d0/d0_blind_id/.libs:$PATH"
2010-05-07 07:40:03 +00:00
elif [ x"`uname`" = x"Darwin" ]; then
export DYLD_LIBRARY_PATH="$d0/misc/buildfiles/osx/Xonotic-SDL.app/Contents/MacOS:$d0/d0_blind_id/.libs"
2010-07-08 20:12:54 +00:00
export DYLD_FRAMEWORK_PATH="$d0/misc/buildfiles/osx/Xonotic-SDL.app/Contents/Frameworks"
2010-05-07 07:40:03 +00:00
client=-sdl
else
export LD_LIBRARY_PATH="$d0/d0_blind_id/.libs"
client=-sdl
fi
case "$1" in
sdl|glx|agl|dedicated)
client=-$1
shift
;;
wgl)
client=
shift
;;
esac
if ! [ -x "darkplaces/darkplaces$client" ]; then
if [ -x "darkplaces/darkplaces$client.exe" ]; then
client=$client.exe
else
echo "Client darkplaces/darkplaces$client not found, aborting"
exit 1
fi
fi
set -- "darkplaces/darkplaces$client" -nexuiz -customgamename Xonotic -customgamedirname1 data -customgamedirname2 "" -customgamescreenshotname xonotic -customgameuserdirname xonotic -mygames "$@"
2010-09-04 14:56:33 +00:00
# change this to:
#set -- "darkplaces/darkplaces$client" -xonotic -mygames "$@"
2010-05-10 19:12:07 +00:00
# if pulseaudio is running: USE IT
2010-06-06 14:07:50 +00:00
if [ -z "$SDL_AUDIODRIVER" ] && ! [ -n "$WE_HATE_OUR_USERS" ] && ! [ x"`uname`" = x"Darwin" ]; then
if ps -C pulseaudio >/dev/null; then
if ldd /usr/lib/libSDL.so 2>/dev/null | grep pulse >/dev/null; then
export SDL_AUDIODRIVER=pulse
fi
2010-05-10 19:12:07 +00:00
fi
fi
if [ -n "$USE_GDB" ]; then
set -- gdb --args "$@"
fi
"$@"
2010-03-24 12:11:30 +00:00
;;
each|foreach)
2010-06-17 12:28:54 +00:00
keep_going=false
if [ x"$1" = x"-k" ]; then
keep_going=true
shift
fi
2010-03-25 14:37:47 +00:00
for d in $repos; do
if verbose cd "$d0/$d"; then
2010-06-17 12:28:54 +00:00
if $keep_going; then
verbose "$@" || true
else
verbose "$@"
fi
cd "$d0"
fi
2010-03-25 14:37:47 +00:00
done
;;
2010-04-15 09:38:55 +00:00
save-patches)
outfile=$1
patchdir=`mktemp -d -t save-patches.XXXXXX`
for d in $repos; do
enter "$d0/$d" verbose
git branch -v -v | cut -c 3- | {
i=0
while read -r BRANCH REV UPSTREAM TEXT; do
case "$UPSTREAM" in
\[*)
UPSTREAM=${UPSTREAM#\[}
UPSTREAM=${UPSTREAM%\]}
UPSTREAM=${UPSTREAM%:*}
TRACK=true
;;
*)
UPSTREAM=origin/"`repobranch "$d"`"
2010-04-15 09:38:55 +00:00
TRACK=false
;;
esac
if [ x"$REV" = x"->" ]; then
continue
fi
2010-04-15 09:43:03 +00:00
if git format-patch -o "$patchdir/$i" "$UPSTREAM".."$BRANCH"; then
2010-04-15 09:38:55 +00:00
echo "$d" > "$patchdir/$i/info.txt"
2010-04-15 09:43:03 +00:00
echo "$BRANCH" >> "$patchdir/$i/info.txt"
2010-04-15 09:38:55 +00:00
echo "$UPSTREAM" >> "$patchdir/$i/info.txt"
echo "$TRACK" >> "$patchdir/$i/info.txt"
i=$(($i+1))
else
rm -rf "$patchdir/$i"
fi
done
}
done
( cd "$patchdir" && tar cvzf - . ) > "$outfile"
rm -rf "$patchdir"
;;
restore-patches)
infile=$1
patchdir=`mktemp -d -t restore-patches.XXXXXX`
( cd "$patchdir" && tar xvzf - ) < "$infile"
# detach the head
for P in "$patchdir"/*/info.txt; do
D=${P%/info.txt}
exec 3<"$P"
read -r d <&3
read -r BRANCH <&3
read -r UPSTREAM <&3
read -r TRACK <&3
verbose git checkout HEAD^0
verbose git branch -D "$BRANCH"
if [ x"$TRACK" = x"true" ]; then
verbose git checkout --track -b "$BRANCH" "$UPSTREAM"
else
verbose git branch -b "$BRANCH" "$UPSTREAM"
fi
verbose git am "$D"
done
rm -rf "$patchdir"
;;
admin-merge)
branch=$1
2010-05-09 17:40:25 +00:00
t=`mktemp`
report=""
reportecho()
{
report=$report"$*$LF"
echo "$*"
}
reportecho4()
{
report=$report" $*$LF"
echo " $*"
}
reportdo4()
{
o=`"$@" | sed 's/^/ /' || true`
reportecho "$o"
}
2010-05-09 17:40:25 +00:00
for d in $repos; do
enter "$d0/$d" verbose
base="`repobranch "$d"`"
reportecho "In $d:"
2010-05-09 17:40:25 +00:00
for ref in `git for-each-ref --format='%(refname)' refs/remotes/origin/`; do
case "${ref#refs/remotes/origin/}" in
"$base")
2010-05-09 17:40:25 +00:00
continue
;;
HEAD|master)
continue
;;
2010-06-24 08:12:48 +00:00
*/*)
;;
2010-06-24 08:12:48 +00:00
*)
continue
;;
2010-05-09 17:40:25 +00:00
esac
if [ -n "$branch" ]; then
if [ x"$branch" != x"${ref#refs/remotes/origin/}" ]; then
continue
fi
fi
case "$base" in
master)
realbase=$base
;;
*)
2010-07-02 12:04:00 +00:00
l0=`git rev-list "$base".."$ref" | wc -l`
l1=`git rev-list master.."$ref" | wc -l`
if [ $l0 -gt $l1 ]; then
realbase=master
else
realbase=$base
fi
;;
esac
reportecho " Branch $ref:"
note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
logdata=`git log --color "$realbase".."$ref"`
if [ -z "$logdata" ]; then
reportecho4 "--> not merging, no changes vs master"
2010-06-24 08:12:48 +00:00
if yesno "Branch \"$ref\" probably should get deleted. Do it?" ''; then
git push origin :"${ref#refs/remotes/origin/}"
reportecho4 "--> branch deleted"
fi
2010-06-24 08:12:48 +00:00
else
diffdata=`git diff --color --find-copies-harder --ignore-space-change "$realbase"..."$ref"`
2010-06-24 08:12:48 +00:00
if [ -z "$diffdata" ]; then
reportecho4 "--> not merging, no changes vs master, branch contains redundant history"
if yesno "Branch \"$ref\" probably should get deleted. Do it?" '{ echo "$logdata"; } | less -r'; then
2010-05-15 18:11:23 +00:00
git push origin :"${ref#refs/remotes/origin/}"
reportecho4 "--> branch deleted"
2010-05-15 18:11:23 +00:00
fi
elif [ -z "$branch" ] && [ -n "$note" ]; then
reportdo4 echo "$note"
2010-06-24 08:12:48 +00:00
reportecho4 "--> not merging, already had this one rejected before"
elif yesno "Branch \"$ref\" may want to get merged. Do it?" '{ echo "$logdata"; echo "$diffdata"; } | less -r'; then
git checkout "$realbase"
2010-06-24 08:12:48 +00:00
org=`git rev-parse HEAD`
if ! git merge --no-ff "$ref" 2>&1 | tee "$t" && ! { git ls-files -u | grep ' 1 ' >/dev/null; }; then
2010-06-24 08:12:48 +00:00
git reset --hard "$org"
GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Merge failed:$LF`cat "$t"`" "$ref"
reportdo4 cat "$t"
reportecho4 "--> merge failed"
2010-07-02 12:01:59 +00:00
elif ! "$SELF" compile -n 2>&1 | tee "$t"; then
2010-06-24 08:12:48 +00:00
git reset --hard "$org"
GIT_NOTES_REF=refs/notes/admin-merge git notes edit -m "Compile failed:$LF`cat "$t"`" "$ref"
reportdo4 cat "$t"
reportecho4 "--> compile failed"
elif ! yesno "Still merge \"$ref\" into `git symbolic-ref HEAD` of $d? Maybe you want to test first."; then
git reset --hard "$org"
2010-07-21 18:13:54 +00:00
GIT_NOTES_REF=refs/notes/admin-merge git notes edit "$ref"
2010-06-24 08:12:48 +00:00
note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
if [ x"$note" = x"del" ]; then
git push origin :"${ref#refs/remotes/origin/}"
reportecho4 "--> test failed, branch deleted"
elif [ -n "$note" ]; then
reportdo4 echo "$note"
reportecho4 "--> test failed"
else
reportecho4 "--> test failed, postponed"
fi
else
2010-07-04 19:37:09 +00:00
echo "MERGING"
2010-06-24 08:12:48 +00:00
case ",`repoflags "$d"`," in
*,svn,*)
# we do quite a mess here... luckily we know $org
git fetch # svn needs to be current
git rebase -i --onto origin/master "$org"
git svn dcommit --add-author-from
git reset --hard "$org"
;;
*)
git push origin HEAD
;;
esac
reportecho4 "--> MERGED"
if yesno "Delete original branch \"$ref\"?"; then
git push origin :"${ref#refs/remotes/origin/}"
reportecho4 "--> branch deleted"
fi
fi
else
2010-06-24 08:12:48 +00:00
GIT_NOTES_REF=refs/notes/admin-merge git notes edit "$ref"
note=`GIT_NOTES_REF=refs/notes/admin-merge git notes show "$ref" 2>/dev/null || true`
if [ x"$note" = x"del" ]; then
git push origin :"${ref#refs/remotes/origin/}"
reportecho4 "--> branch deleted"
elif [ -n "$note" ]; then
reportdo4 echo "$note"
reportecho4 "--> rejected"
else
reportecho4 "--> postponed"
fi
fi
2010-05-09 17:40:25 +00:00
fi
reportecho ""
2010-05-09 17:40:25 +00:00
done
reportecho ""
2010-05-09 17:40:25 +00:00
done
rm -f "$t"
echo "$report" | ssh nexuiz@rm.endoftheinternet.org cat '>>' public_html/xonotic-merge-notes.txt
2010-05-09 17:40:25 +00:00
;;
2010-08-09 11:59:42 +00:00
clean)
2010-08-09 12:01:18 +00:00
force=false
if [ x"$1" = x"-f" ]; then
force=true
fi
2010-08-09 11:59:42 +00:00
for d in $repos; do
verbose cd "$d0/$d"
2010-08-09 12:01:18 +00:00
if $force; then
verbose git reset --hard
#redundant# verbose git checkout-index -fa
2010-08-09 12:01:18 +00:00
fi
2010-08-09 11:59:42 +00:00
case "$d" in
.)
2010-08-09 12:01:51 +00:00
verbose git clean -df
2010-08-09 11:59:42 +00:00
;;
*)
2010-08-09 12:01:51 +00:00
verbose git clean -xdf
2010-08-09 11:59:42 +00:00
;;
esac
done
;;
# release building goes here
release-prepare)
2010-08-02 14:01:58 +00:00
#"$SELF" each git clean -fxd
2010-08-06 09:49:18 +00:00
case "$RELEASETYPE" in
beta)
msg "Building a BETA"
;;
release)
msg "Building a RELEASE"
;;
*)
msg "Must either set RELEASETYPE=beta or RELEASETYPE=release"
exit 1
;;
esac
2010-08-06 09:48:00 +00:00
verbose rm -rf Xonotic Xonotic*.zip
verbose mkdir -p Xonotic
2010-09-03 07:07:26 +00:00
if [ -n "$RELEASEDATE" ]; then
verbose echo "$RELEASEDATE" > Xonotic/stamp.txt
else
verbose date +%Y%m%d > Xonotic/stamp.txt
fi
2010-08-12 14:22:33 +00:00
verbose git archive --format=tar HEAD -- Docs misc server xonotic-linux-glx.sh xonotic-linux-sdl.sh misc/buildfiles key_0.d0pk | {
2010-08-06 09:48:00 +00:00
verbose cd Xonotic
verbose mkdir data fteqcc source source/darkplaces source/fteqcc
verbose tar xvf -
verbose rm -rf misc/builddeps
verbose mv misc/buildfiles/win32/* . || true
2010-08-11 04:36:32 +00:00
verbose mv misc/buildfiles/win64 bin64 || true
2010-08-06 09:48:00 +00:00
verbose mv misc/buildfiles/osx/* . || true
verbose rm -rf misc/buildfiles
2010-08-12 14:22:53 +00:00
verbose rm -rf misc/pki
2010-08-02 14:01:58 +00:00
}
{
2010-08-06 09:48:00 +00:00
verbose cd darkplaces
verbose git archive --format=tar HEAD
} | {
2010-08-06 09:48:00 +00:00
verbose cd Xonotic/source/darkplaces
verbose tar xvf -
}
{
2010-08-06 09:48:00 +00:00
verbose cd fteqcc
verbose git archive --format=tar HEAD
} | {
2010-08-06 09:48:00 +00:00
verbose cd Xonotic/source/fteqcc
verbose tar xvf -
2010-08-06 07:27:05 +00:00
}
{
2010-08-06 09:48:00 +00:00
verbose cd data/xonotic-data.pk3dir
verbose git archive --format=tar HEAD -- qcsrc Makefile
2010-08-06 07:27:05 +00:00
} | {
2010-08-06 09:48:00 +00:00
verbose cd Xonotic/source
verbose tar xvf -
2010-08-02 14:01:58 +00:00
}
2010-08-12 14:22:53 +00:00
rm -f Xonotic/key_15.d0pk
;;
release-compile-run)
host=$1
buildpath=$2
maketargets=$3
makeflags=$4
srcdir=$5
targetfiles=$6
if [ -n "$targetfiles" ]; then
case " $HOSTS_THAT_ARE_MYSELF " in
*\ $host\ *)
verbose rsync --delete -zvaSHP "$srcdir"/ "$buildpath/"
verbose eval make -C "$buildpath" clean $maketargets $makeflags
for f in $targetfiles; do
verbose mv "$buildpath/${f%:*}" "${f##*:}" || true
done
;;
*)
verbose rsync --delete -zvaSHP "$srcdir"/ "$host:$buildpath/"
verbose ssh "$host" ". ~/.profile && cd $buildpath && make clean $maketargets $makeflags"
for f in $targetfiles; do
verbose rsync -zvaSHP "$host:$buildpath/${f%:*}" "${f##*:}" || true
done
;;
esac
# now rebrand the binaries...
for f in $targetfiles; do
2010-09-04 14:56:33 +00:00
#verbose "$d0/misc/tools/rebrand-darkplaces-engine.sh" "${XONOTIC_BRAND:-$d0/misc/tools/xonotic.brand}" "${f##*:}" || true
case "$f" in
xonotic*.exe)
verbose "$d0/misc/tools/change-icon-of-exe.sh" "$d0/misc/logos/icons_ico/xonotic.ico" "$f"
(
d=`mktemp -d -t rebrand.XXXXXX`
cd "$d"
echo "-mygames" > darkplaces.opt
zip -9r darkplaces.zip darkplaces.opt
cat darkplaces.zip
cd "$d0"
rm -rf "$d"
) >> "$f"
;;
esac
done
fi
;;
release-compile)
suffix=$1
makeflags=$2
fteqcc_maketargets=$3
fteqcc_files=$4
darkplaces_maketargets=$5
darkplaces_files=$6
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/fteqcc.build."$suffix" "$fteqcc_maketargets" "$makeflags" "Xonotic/source/fteqcc" "$fteqcc_files"
verbose "$SELF" release-compile-run "xonotic-build-$suffix" /tmp/Darkplaces.build."$suffix" "$darkplaces_maketargets" "$makeflags" "Xonotic/source/darkplaces" "$darkplaces_files"
;;
2010-06-17 13:20:57 +00:00
release-engine-win32)
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-compile win32 \
'STRIP=: DP_MAKE_TARGET=mingw CC="i586-mingw32msvc-g++ -g -Wl,--dynamicbase -Wl,--nxcompat -I$HOME/dp.win32/include -L$HOME/dp.win32/lib" WINDRES="i586-mingw32msvc-windres" SDL_CONFIG="$HOME/dp.win32/bin/sdl-config" LIB_JPEG= CFLAGS_LIBJPEG= WIN32RELEASE=1 D3D=1' \
win 'fteqcc.exe:Xonotic/fteqcc/fteqcc.exe' \
2010-08-11 04:36:32 +00:00
release 'darkplaces.exe:Xonotic/xonotic.exe darkplaces-sdl.exe:Xonotic/xonotic-sdl.exe darkplaces-dedicated.exe:Xonotic/xonotic-dedicated.exe'
;;
2010-07-02 12:44:22 +00:00
release-engine-win64)
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-compile win64 \
'STRIP=: DP_MAKE_TARGET=mingw CC="amd64-mingw32msvc-g++ -g -Wl,--dynamicbase -Wl,--nxcompat -I$HOME/dp.win64/include -L$HOME/dp.win64/lib" WINDRES="amd64-mingw32msvc-windres" SDL_CONFIG="$HOME/dp.win64/bin/sdl-config" LIB_JPEG= CFLAGS_LIBJPEG= WIN64RELEASE=1 D3D=1' \
2010-08-09 13:23:19 +00:00
win 'fteqcc.exe:Xonotic/fteqcc/fteqcc-x64.exe' \
2010-08-15 19:08:35 +00:00
'sv-release cl-release' 'darkplaces.exe:Xonotic/xonotic-x64.exe darkplaces-dedicated.exe:Xonotic/xonotic-dedicated-x64.exe'
# release 'darkplaces.exe:Xonotic/xonotic-x64.exe darkplaces-sdl.exe:Xonotic/xonotic-sdl-x64.exe darkplaces-dedicated.exe:Xonotic/xonotic-dedicated-x64.exe'
2010-07-02 12:44:22 +00:00
;;
release-engine-osx-sv-sdl)
# gcc on OSX is buggy, needs -fno-reorder-blocks for a release build to succeed
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-compile osx \
'STRIP=: CC="gcc -g -arch i386 -arch ppc -arch x86_64 -isysroot /Developer/SDKs/MacOSX10.5.sdk -mmacosx-version-min=10.4 -I$HOME/dp.osx/include -L$HOME/dp.osx/lib -fno-reorder-blocks"' \
all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.osx' \
'sv-release sdl-release' 'darkplaces-sdl:Xonotic/Xonotic-SDL.app/Contents/MacOS/xonotic-osx-sdl-bin darkplaces-dedicated:Xonotic/xonotic-osx-dedicated'
;;
release-engine-osx-agl)
# gcc on OSX is buggy, needs -fno-reorder-blocks for a release build to succeed
verbose "$SELF" release-compile osx \
'STRIP=: CC="gcc -g -arch i386 -arch ppc -isysroot /Developer/SDKs/MacOSX10.5.sdk -mmacosx-version-min=10.4 -I$HOME/dp.osx/include -L$HOME/dp.osx/lib -fno-reorder-blocks"' \
'' '' \
2010-08-27 15:04:02 +00:00
'cl-release' 'darkplaces-agl:Xonotic/Xonotic.app/Contents/MacOS/xonotic-osx-agl-bin'
;;
release-engine-osx)
verbose "$SELF" release-engine-osx-sv-sdl
verbose "$SELF" release-engine-osx-agl
2010-06-17 13:20:57 +00:00
;;
release-engine-linux32)
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-compile linux32 \
2010-08-27 09:43:14 +00:00
'STRIP=: CC="gcc -m32 -g -Wl,--hash-style=sysv -I$HOME/dp.linux32/include -L$HOME/dp.linux32/lib" DP_MODPLUG_STATIC_LIBDIR=$HOME/dp.linux32/lib LIB_JPEG=$HOME/dp.linux32/lib/libjpeg.a DP_CRYPTO_STATIC_LIBDIR=$HOME/dp.linux32/lib' \
all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux32' \
2010-08-11 04:36:32 +00:00
release 'darkplaces-glx:Xonotic/xonotic-linux32-glx darkplaces-sdl:Xonotic/xonotic-linux32-sdl darkplaces-dedicated:Xonotic/xonotic-linux32-dedicated'
2010-06-17 13:20:57 +00:00
;;
release-engine-linux64)
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-compile linux64 \
2010-08-27 09:43:14 +00:00
'STRIP=: CC="gcc -m64 -g -Wl,--hash-style=sysv -I$HOME/dp.linux64/include -L$HOME/dp.linux64/lib" DP_MODPLUG_STATIC_LIBDIR=$HOME/dp.linux64/lib LIB_JPEG=$HOME/dp.linux64/lib/libjpeg.a DP_CRYPTO_STATIC_LIBDIR=$HOME/dp.linux64/lib' \
all 'fteqcc.bin:Xonotic/fteqcc/fteqcc.linux64' \
2010-08-11 04:36:32 +00:00
release 'darkplaces-glx:Xonotic/xonotic-linux64-glx darkplaces-sdl:Xonotic/xonotic-linux64-sdl darkplaces-dedicated:Xonotic/xonotic-linux64-dedicated'
2010-06-17 13:20:57 +00:00
;;
release-engine)
verbose "$SELF" release-engine-linux32 &
verbose "$SELF" release-engine-linux64 &
verbose "$SELF" release-engine-win32 &
verbose "$SELF" release-engine-win64 &
verbose "$SELF" release-engine-osx &
wait %1
wait %2
wait %3
wait %4
wait %5
wait
;;
release-maps)
2010-08-06 09:48:00 +00:00
verbose "$SELF" update-maps
2010-06-17 13:20:57 +00:00
;;
2010-06-28 12:27:27 +00:00
release-qc)
2010-08-06 09:48:00 +00:00
case "$RELEASETYPE" in
beta)
2010-08-06 10:00:40 +00:00
verbose make -C Xonotic/source FTEQCC="$d0/Xonotic/fteqcc/fteqcc.linux32" XON_BUILDSYSTEM=1 clean all
2010-08-06 09:48:00 +00:00
;;
release)
2010-08-06 10:00:40 +00:00
verbose make -C Xonotic/source FTEQCC="$d0/Xonotic/fteqcc/fteqcc.linux32" XON_BUILDSYSTEM=1 FTEQCCFLAGS_WATERMARK= clean all
2010-08-06 09:48:00 +00:00
;;
esac
verbose rm -f Xonotic/source/*/fteqcc.log
2010-06-28 12:27:27 +00:00
;;
2010-06-17 13:20:57 +00:00
release-buildpk3-transform-raw)
dir=$1
2010-06-17 13:20:57 +00:00
;;
release-buildpk3-transform-normal)
dir=$1
2010-08-06 09:48:00 +00:00
verbose cd "$dir"
# texture: convert to jpeg and dds
2010-08-06 09:48:00 +00:00
verbose export do_jpeg=true
verbose export jpeg_qual_rgb=95
verbose export jpeg_qual_a=99
verbose export do_dds=true
verbose export dds_flags=
verbose export do_ogg=false
verbose export del_src=true
find . -type f -print0 | verbose xargs -0 "$d0"/misc/tools/cached-converter.sh
2010-06-17 13:20:57 +00:00
;;
release-buildpk3-transform-low)
dir=$1
2010-08-06 09:48:00 +00:00
verbose cd "$dir"
# texture: convert to jpeg and dds
2010-06-17 13:20:57 +00:00
# music: reduce bitrate
2010-08-06 09:48:00 +00:00
verbose export do_jpeg=true
verbose export jpeg_qual_rgb=80
verbose export jpeg_qual_a=95
verbose export do_dds=false
verbose export do_ogg=true
verbose export ogg_qual=1
verbose export del_src=true
find . -type f -print0 | verbose xargs -0 "$d0"/misc/tools/cached-converter.sh
2010-06-17 13:20:57 +00:00
;;
release-buildpk3-transform-lowdds)
dir=$1
2010-08-06 09:48:00 +00:00
verbose cd "$dir"
# texture: convert to jpeg and dds
# music: reduce bitrate
2010-08-06 09:48:00 +00:00
verbose export do_jpeg=false
verbose export do_jpeg_if_not_dds=true
verbose export jpeg_qual_rgb=80
verbose export jpeg_qual_a=95
verbose export do_dds=true
verbose export dds_flags=
verbose export do_ogg=true
verbose export ogg_qual=1
verbose export del_src=true
find . -type f -print0 | verbose xargs -0 "$d0"/misc/tools/cached-converter.sh
2010-06-17 13:20:57 +00:00
;;
release-buildpk3)
src=$1
dst=$2
transform=$3
case "$dst" in
/*)
;;
2010-06-17 13:23:22 +00:00
*/)
2010-06-17 13:20:57 +00:00
dst="$PWD/$dst"
;;
esac
2010-08-06 09:48:00 +00:00
verbose rm -rf Xonotic/temp
verbose mkdir -p Xonotic/temp
2010-08-02 14:01:58 +00:00
{
2010-08-06 09:48:00 +00:00
verbose cd "$src"
verbose git archive --format=tar HEAD
2010-08-02 14:01:58 +00:00
} | {
2010-08-06 09:48:00 +00:00
verbose cd Xonotic/temp
verbose tar xvf -
2010-08-02 14:01:58 +00:00
}
2010-08-06 09:48:00 +00:00
verbose cd Xonotic/temp
2010-08-02 14:01:58 +00:00
if [ x"$src" = x"data/xonotic-data.pk3dir" ]; then
2010-08-06 10:19:30 +00:00
verbose cp ../source/progs.dat .
verbose cp ../source/csprogs.dat .
verbose cp ../source/menu.dat .
2010-08-06 09:48:00 +00:00
verbose rm -rf qcsrc
gv=`grep "^gameversion " "defaultXonotic.cfg" | awk '{ print $2 }'`
major=$(($gv / 10000))
minor=$(($gv / 100 - $major * 100))
patch=$(($gv - $major * 10000 - $minor * 100))
2010-08-06 09:48:00 +00:00
verbose sed -i "
s/^set g_xonoticversion [^ ]* /set g_xonoticversion $major.$minor.$patch /;
s/^gameversion_min [0-9]*/gameversion_min $(( ($gv / 100) * 100 - 100 ))/;
s/^gameversion_max [0-9]*/gameversion_max $(( ($gv / 100) * 100 + 199 ))/;
" defaultXonotic.cfg
2010-08-02 14:01:58 +00:00
fi
2010-08-06 07:27:05 +00:00
if [ x"$src" = x"data/xonotic-maps.pk3dir" ]; then
for X in ../../data/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
2010-08-06 07:27:05 +00:00
if [ -f "$X" ]; then
2010-08-06 09:48:00 +00:00
verbose unzip "$X"
2010-08-06 07:27:05 +00:00
fi
done
fi
verbose export git_src_repo="$d0/$src" # skip hash-object
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-buildpk3-transform-$transform "Xonotic/temp"
verbose zip -9yr "../../$dst" .
verbose cd ../..
verbose rm -rf Xonotic/temp
2010-06-17 13:20:57 +00:00
;;
release-buildpk3s)
2010-08-05 18:01:27 +00:00
stamp=`cat Xonotic/stamp.txt`
2010-06-17 13:20:57 +00:00
src=$1
shift
2010-08-05 18:01:27 +00:00
dst=${src%.pk3dir}
case "$dst" in
data/xonotic-*)
2010-08-05 18:54:32 +00:00
dst="data/xonotic-$stamp-${dst#data/xonotic-}"
2010-08-05 18:01:27 +00:00
;;
*)
dst="$dst-$stamp"
;;
esac
2010-06-17 13:20:57 +00:00
while [ "$#" -gt 1 ]; do
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-buildpk3 "$src" "Xonotic/$dst$2.pk3" "$1"
shift
shift
2010-06-17 13:20:57 +00:00
done
;;
release-pack)
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-buildpk3s data/font-nimbussansl.pk3dir raw ''
verbose "$SELF" release-buildpk3s data/xonotic-data.pk3dir normal '' raw '-raw' low '-low' lowdds '-lowdds'
verbose "$SELF" release-buildpk3s data/xonotic-maps.pk3dir normal '' raw '-raw' low '-low' lowdds '-lowdds'
verbose "$SELF" release-buildpk3s data/xonotic-music.pk3dir raw '' low '-low'
verbose "$SELF" release-buildpk3s data/xonotic-nexcompat.pk3dir low ''
;;
2010-08-05 08:59:22 +00:00
release-pack-needsx11)
case "$DISPLAY" in
'')
2010-08-06 09:48:00 +00:00
verbose startx "$SELF" release-pack -- /usr/bin/Xvfb :7
2010-08-05 08:59:22 +00:00
;;
*)
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-pack
2010-08-05 08:59:22 +00:00
;;
esac
;;
2010-08-05 18:01:27 +00:00
release-zip)
2010-08-06 04:30:26 +00:00
stamp=`cat Xonotic/stamp.txt`
2010-09-04 16:01:13 +00:00
verbose zip -9yr Xonotic-$stamp-engine.zip \
2010-08-05 18:01:27 +00:00
Xonotic/*.dll \
2010-09-04 16:01:13 +00:00
Xonotic/bin64/*.dll \
Xonotic/*.app \
Xonotic/xonotic-* \
Xonotic/xonotic.exe
verbose cp Xonotic-$stamp-engine.zip Xonotic-$stamp-common.zip
verbose zip -9yr Xonotic-$stamp-common.zip \
2010-08-06 10:19:30 +00:00
Xonotic/source/*/ \
2010-08-05 18:01:27 +00:00
Xonotic/Docs \
Xonotic/misc \
Xonotic/fteqcc \
Xonotic/server \
2010-09-03 07:06:50 +00:00
Xonotic/key_0.d0pk \
2010-08-06 04:30:26 +00:00
Xonotic/data/font-nimbussansl-$stamp.pk3
verbose cp Xonotic-$stamp-common.zip Xonotic-$stamp.zip
verbose zip -0yr Xonotic-$stamp.zip \
2010-08-06 04:30:26 +00:00
Xonotic/data/xonotic-$stamp-data.pk3 \
Xonotic/data/xonotic-$stamp-maps.pk3 \
Xonotic/data/xonotic-$stamp-music.pk3 \
Xonotic/data/xonotic-$stamp-nexcompat.pk3
verbose cp Xonotic-$stamp-common.zip Xonotic-$stamp-low.zip
verbose zip -0yr Xonotic-$stamp-low.zip \
2010-08-06 04:30:26 +00:00
Xonotic/data/xonotic-$stamp-data-low.pk3 \
Xonotic/data/xonotic-$stamp-maps-low.pk3 \
Xonotic/data/xonotic-$stamp-music-low.pk3
verbose cp Xonotic-$stamp-common.zip Xonotic-$stamp-lowdds.zip
verbose zip -0yr Xonotic-$stamp-lowdds.zip \
2010-08-06 04:30:26 +00:00
Xonotic/data/xonotic-$stamp-data-lowdds.pk3 \
Xonotic/data/xonotic-$stamp-maps-lowdds.pk3 \
Xonotic/data/xonotic-$stamp-music-low.pk3
verbose mv Xonotic-$stamp-common.zip Xonotic-$stamp-high.zip
verbose zip -0yr Xonotic-$stamp-high.zip \
2010-08-06 04:30:26 +00:00
Xonotic/data/xonotic-$stamp-data-raw.pk3 \
Xonotic/data/xonotic-$stamp-maps-raw.pk3 \
Xonotic/data/xonotic-$stamp-music.pk3 \
Xonotic/data/xonotic-$stamp-nexcompat.pk3
;;
release)
2010-08-06 09:48:00 +00:00
verbose "$SELF" release-prepare
verbose "$SELF" release-maps
verbose "$SELF" release-engine
verbose "$SELF" release-qc
verbose "$SELF" release-pack-needsx11
verbose "$SELF" release-zip
;;
2010-08-02 14:04:48 +00:00
2010-03-18 15:46:07 +00:00
*)
echo "Usage:"
echo " $SELF pull"
echo " $SELF merge"
echo " $SELF push [-s]"
echo " $SELF branches"
echo " $SELF branch [<remote>] <branchname>"
echo " $SELF branch <remote> <branchname> <srcbranchname>"
echo " $SELF checkout [<remote>] <branchname>"
echo " $SELF compile [-c|-n] [<client>] <options>"
echo " $SELF run [<client>] <options>"
echo " $SELF each <command>"
2010-03-18 15:46:07 +00:00
;;
esac